package cn.net.caoyao.cpzshandset.service.thread.impl.yth;

import java.io.IOException;
import java.net.SocketTimeoutException;
import java.util.List;

import android.os.Handler;
import android.os.Message;

import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.service.bll.TrainStationBll;
import cn.net.cpzslibs.prot.Prot02Logout;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20012ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.TrainStationBean;
import cn.net.cpzslibs.prot.handset.newProt.Prot20012ReqTrainStation;

public class YthReqTrainStationRunable implements Runnable {
	private Handler mHandler;
	private long deveicedId; 
	private TrainStationBll stationBll;
	public YthReqTrainStationRunable(Handler mHandler, long deveicedId,TrainStationBll stationBll) {
		this.mHandler = mHandler;
		this.deveicedId = deveicedId;
		this.stationBll = stationBll;
	}

	@Override
	public void run() {
		SocketCreate create = new SocketCreate(Config.ip, Config.port, String.valueOf(deveicedId));
		try {
			create.createLoginCpzsHandset(deveicedId);
			if (create.isResult()) {
				Prot20012ReqTrainStation stationReq = new Prot20012ReqTrainStation();
				stationReq.dealStationList(create);
				Prot20012ResBean resBean = stationReq.getStations();
				if (resBean.getResult() == 0) {
					//0：请求成功     1：遇到错误信息，返回错误码
					if (resBean.getAc() != null && resBean.getAc().size()>0) {
						insertStationInfo(resBean.getAc());
					}else {
						mHandler.sendEmptyMessage(RequestConstant.PROT_REQ_TRAIN_STATION_20012_NO_DATA);
					}
				} else {
					Message failMsg = mHandler.obtainMessage();
					failMsg.what = RequestConstant.PROT_REQ_TRAIN_STATION_20012_FAIL;
					failMsg.obj = resBean;
					mHandler.sendMessage(failMsg);
				}
				
			} else {
//				mHandler.sendEmptyMessage(ThreadConstant.)
				Message loginFailMsg = mHandler.obtainMessage();
				loginFailMsg.obj = create.getErrMsg();
				loginFailMsg.arg1 = create.getiErrCode();
				loginFailMsg.what = RequestConstant.REQUEST_PROT01_LOGIN_FAIL;
				mHandler.sendMessage(loginFailMsg);
			}
		}catch (SocketTimeoutException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT);
		} catch (IOException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} finally{
			new Prot02Logout().dealLogout(create);
		}
	}

	private void insertStationInfo(List<TrainStationBean> ac) {
//		List<StationManagerBean> stations = new ArrayList<StationManagerBean>();
		stationBll.deleteAllStation();
		stationBll.insertAllTrainStaion(ac);
		mHandler.sendEmptyMessage(RequestConstant.PROT_REQ_TRAIN_STATION_20012_SUCCESS);
	}

}
